C   This perticular program is suitable for polycrystalline 
C   austenitic structure.
C-------------------------------------------------------------------------------------------
C
C   1. Following the Bragg's law in the reciprocal lattice space this program gives the 
C      diffraction rings of the deformed austenite phase.

C   2. Austenite might or might not be textured. The program takes this as input.

C   3. The difrraction rings are suppose to give a good idea about the texture of the austenite

C   4. The incident beam is assumed to be parallel to the Z-axis in the sample reference frame.

C   5. The axis of stress in the austenite phase is assumed to be in the direction of X-axis 
C      in the sample reference frame.

C      
C------------------------------------------------------------------------------------------ 
C   Developed by Saurabh kundu in the month of June-July, 2006, Jamshedpur

C   


      PROGRAM DIFFRACT
      
      IMPLICIT NONE
      
      INTEGER DMAX,RW,RWW,RWWW,RW_TR,RR
      DOUBLE PRECISION PI
      
      PARAMETER (DMAX=24,RW=99,RWW=98,RWWW=97,RW_TR=96,RR=62,
&                PI=3.141592654)
      
      INTEGER I,J,Q,ISEED,COUNT,NO_GRAINS,S,M
      
      DOUBLE PRECISION HABIT(DMAX,3),DIRECTION(DMAX,3),SIGMA(3)
      DOUBLE PRECISION TEMP(7),SIGMA_START(3),ANGLE
      DOUBLE PRECISION P(3),DIREC(3),N(3),K(3),SH_TEMP(3),D(3)
      DOUBLE PRECISION TAO_TEMP(3),TAO(DMAX,3),SHEAR(DMAX,3)
      DOUBLE PRECISION U(DMAX),TRANS_MATRIX(3,3),SIGMA_TEMP(3)
      DOUBLE PRECISION THETA(DMAX),PHI(DMAX),AVG_U(DMAX)
      DOUBLE PRECISION BETA,ANGM,ANGN,A,B,ALL_INFO(24,4),STRESS
      DOUBLE PRECISION AL_J_GM(72,3),AL_J_GM_TEMP(72,3),X_ST,Y_ST
      DOUBLE PRECISION AL(30,3),MAT_INV(3,3),GM_J_AL(72,3),KK
      DOUBLE PRECISION TATA(3,3),GM_CONV_TEMP(30,3),GM_CONV(30,3)
      DOUBLE PRECISION GM_CONV_HABIT_TEMP(30,3),DEF_MAT(3,3)
      DOUBLE PRECISION GM_CONV_HABIT(30,3),TRANS_MATRIX_INV(3,3)
      DOUBLE PRECISION ALPH_NEW,P_INTO_D,STRESS_TENSOR(3,3),SH,DI
      DOUBLE PRECISION OBS_PLANE(3),OBS_PLANE_START(3),OBS_PLANE_TEMP(3)
      DOUBLE PRECISION SAMPLE_X(3),SAMPLE_Y(3),SAMPLE_Z(3),N_RES(3)
      DOUBLE PRECISION LAMBDA(3),DIFF(3),WAVE_LEN,AALPHA,AL_START(30,3)
      DOUBLE PRECISION AL_TEMP(30,3),INS_BEAM(3),INS_BEAM_ST(3)
      INTEGER ONE,TWO,TH,FOU,FIF,SIX,VAR,TEXTURE
      INTEGER TIMES(3),COUNT_TRACE(18)
      REAL TAG,CRYSTAL
      INTEGER NO_POLES,LOAD
      CALL ITIME(TIMES)
      ISEED=TIME()
      CALL SRAND(ISEED)
      
      INS_BEAM_ST(1)=0
      INS_BEAM_ST(2)=0
      INS_BEAM_ST(3)=1
      
      TEMP(1)=0
         TEMP(2)=0
         TEMP(3)=0
         TEMP(4)=0
      TAG=0
      ONE=0
      TWO=0
      TH=0
      FOU=0
      FIF=0
      SIX=0

C Define incident beam, with magnitude 1/lambda    
C WAVE_LEN has units of nanometers

      
      
c      WRITE(*,*) 'IF AUSTENITE PUT 0 IF FERRITE PUT 1: '
C      READ(*,*) CRYSTAL
      CRYSTAL=1
      IF(TEXTURE .EQ. 1) THEN
        OPEN(RR,FILE='matrix-bias-texture-cu-500.txt',STATUS='OLD')
      ELSE IF(TEXTURE .EQ. 2) THEN
        OPEN(RR,FILE='matrix-bias-texture-brass-500.txt',STATUS='OLD')
      ELSE IF(TEXTURE .EQ. 3) THEN
        OPEN(RR,FILE='matrix-bias-texture-goss-500.txt',STATUS='OLD')
      ELSE IF(TEXTURE .EQ. 4) THEN
        OPEN(RR,FILE='matrix-bias-texture-cube-500.txt',STATUS='OLD')   
      ELSE IF(TEXTURE .EQ. 5) THEN
        OPEN(RR,FILE='matrix-bias-texture-110-111-500.txt',STATUS='OLD')   
      ELSE IF(TEXTURE .EQ. 6) THEN
        OPEN(RR,FILE='matrix-bias-texture-mixture-500.txt',STATUS='OLD') 
      END IF
      WRITE(*,*) 'WHAT IS THE STARTING TEXTURE OF AUSTENITE: '
      WRITE(*,*) '0=RANDOM'
      WRITE(*,*) '1=COPPER'
      WRITE(*,*) '2=BRASS'
      WRITE(*,*) '3=GOSS'
      WRITE(*,*) '4=CUBE'
      WRITE(*,*) '5={110}<111>'
      WRITE(*,*) '6=MIXTURE'
      READ(*,*) TEXTURE
c      TEXTURE=2
c      WRITE(*,*) 'HOW MANY VARIANTS WORKING?'
C      READ(*,*) VAR
      VAR=24
C      READ(*,*) CRYSTAL
      
c      WRITE(*,*) 'PUT THE VALUE OF STRESS? '
c      READ(*,*) STRESS
c      WRITE(*,*) 'IS THE LOAD COMPRESSIVE (0) OR TENSILE (1)? '
c      READ(*,*) LOAD
      
      CALL READING(HABIT,DIRECTION,GM_J_AL,TRANS_MATRIX,NO_POLES,
&      AL_START,AL_TEMP,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,OBS_PLANE,
&      OBS_PLANE_START,COUNT_TRACE,STRESS_TENSOR,SH,DI,TEXTURE,RR) 
 
      WRITE(*,*) 'HOW MANY GRAINS? '
      READ(*,*) NO_GRAINS
      
      COUNT=1   
      
C      
C THE FILE XY-STEREO CONTAINS THE XY DATA OF THE STEREOGRAM 
C

      OPEN(RW,FILE='xy-stereo.txt',STATUS='OLD')
      OPEN(RWW,FILE='xy-diff.txt',STATUS='OLD')
      OPEN(RWWW,FILE='xy-habit.txt',STATUS='OLD')
      OPEN(RW_TR,FILE='trace_angle.txt',STATUS='OLD')
      
      CALL CALCULATE_INVERSE(TRANS_MATRIX,TRANS_MATRIX_INV)
      
C     
C Do loop 10 is taking care of the number of grains in the microstructure
C
      DO 10 WHILE(COUNT .LE. NO_GRAINS-1)
      
         DO 11 I=1,3
            DO 12 J=1,3
               DEF_MAT(I,J)=0
12          CONTINUE
11       CONTINUE
            
         CALL CAL_DEFMAT(TRANS_MATRIX,TRANS_MATRIX_INV,
&                 STRESS_TENSOR,DEF_MAT)
      
C         WRITE(*,*) 'STRESS=',STRESS
C Calculating the unit vector in the direction of maximum shear stress
C Do loop 20 takes care of the 24 variants of martensite
C
         
         DO 20 I=1,DMAX 
      
            DO 30 J=1,3
               P(J)=HABIT(I,J)
   30       CONTINUE
   
            CALL TENSOR_CALC(SIGMA,DEF_MAT,P,STRESS)
            
            CALL CAL_THETA(P,SIGMA,THETA,I)
   
            CALL CROSS_PROD(P,SIGMA,K)
         
            IF(THETA(I) .LT. PI/2) THEN
              BETA=PI/2-THETA(I)
            ELSE
              BETA=THETA(I)-PI/2
            ENDIF
         
            D(1)=0
            D(2)=0
            D(3)=COS(BETA)
         
C           WRITE(*,*) 'THE VALUE OF K = ', K(1), K(2), K(3)
         
            CALL CRAMER(TAO_TEMP,P,K,SIGMA,D)
         
            DO 40 J=1,3
               TAO(I,J)=TAO_TEMP(J)
   40       CONTINUE        
   
  
C ** Calculating the unit vector in the direction of maximum shear stress ****

C ** Calculating the unit vector in the direction of shear stress on the HP ** 
       
            DO 50 J=1,3
               DIREC(J)=DIRECTION(I,J)
   50       CONTINUE
   
            CALL CROSS_PROD(P,DIREC,N)
            
            P_INTO_D=P(1)*DIREC(1)+P(2)*DIREC(2)+P(3)*DIREC(3)
            
            P_INTO_D=ACOS(P_INTO_D)
            
            IF(P_INTO_D .LE. PI/2) THEN
              ALPH_NEW=PI/2-P_INTO_D
            ELSE
              ALPH_NEW=P_INTO_D-PI/2
            END IF
               
            D(1)=0
            D(2)=0
            D(3)=COS(ALPH_NEW)
         
            CALL CRAMER(SH_TEMP,P,N,DIREC,D)
         
            DO 60 J=1,3
               SHEAR(I,J)=SH_TEMP(J)
   60       CONTINUE  
   

   
C ******************************************************************************

C
C ************Calculation of angle phi and mechanical driving force ***********
C
            CALL CALCULATE_PHI(TAO_TEMP,SH_TEMP,PHI,I)   
         
            CALL CALCULATE_MECH_ENG(THETA,PHI,BETA,U,I,STRESS,SH,DI)
            
            
C *****************************************************************************
   
   20    CONTINUE
   
C ***** Calculation of the equivalent gamma pole for a given alpha pole *******  

         CALL SORTING(THETA,PHI,U,ALL_INFO)
         
c         CALL WRITING(ALL_INFO)
C         WRITE(*,*) 'KI JE KORI...'
       
         IF(STRESS .EQ. 0) THEN
           IF(CRYSTAL .EQ. 1) THEN
             J=24
           ELSE IF(CRYSTAL .EQ. 0) THEN
             J=1
           END IF     
           
           DO 70 I=1,J
           
           
              CALL GET_XY(ALL_INFO(I,1),GM_J_AL,X_ST,Y_ST,
&              AL,TRANS_MATRIX,NO_POLES,GM_CONV_TEMP,
&              GM_CONV,CRYSTAL,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,
&               TRANS_MATRIX_INV)
            
            IF(CRYSTAL .EQ. 1) THEN
              CALL GET_XY_HABIT(ALL_INFO(I,1),GM_J_AL,X_ST,Y_ST,
&                HABIT,TRANS_MATRIX,NO_POLES,GM_CONV_HABIT_TEMP,
&                GM_CONV_HABIT,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,
&                TRANS_MATRIX_INV)
              CALL GET_TRACE_ON_HABIT(ALL_INFO(I,1),HABIT
&                  ,OBS_PLANE,SIGMA,COUNT_TRACE)  
            END IF
            
   70      CONTINUE   
   
         ELSE 
            
            J=VAR                       
           
           DO 80 I=1,J

              CALL GET_XY(ALL_INFO(I,1),GM_J_AL,X_ST,Y_ST,
&              AL,TRANS_MATRIX,NO_POLES,GM_CONV_TEMP,
&              GM_CONV,CRYSTAL,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,
&              TRANS_MATRIX_INV)

            IF(CRYSTAL .EQ. 1) THEN
               CALL GET_XY_HABIT(ALL_INFO(I,1),GM_J_AL,X_ST,Y_ST,
&                 HABIT,TRANS_MATRIX,NO_POLES,GM_CONV_HABIT_TEMP,
&                   GM_CONV_HABIT,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,
&                 TRANS_MATRIX_INV)
               CALL GET_TRACE_ON_HABIT(ALL_INFO(I,1),HABIT
&                  ,OBS_PLANE,SIGMA,COUNT_TRACE)  
            END IF
   80      CONTINUE   
           
         END IF
               
   
c         write(*,*) 'next grain .....'
     
         
C *****************************************************************************       

      IF(TEXTURE .EQ. 0) THEN
C ********* Generating the random number to get rotation axis and angle *******                  
         I=1
         DO 88 WHILE(I .LE. 3)
            A=RAND()

            IF(I .NE. 2) THEN
               TEMP(I)=2*PI*A
            ELSE
              TEMP(I)=2*A-1
            END IF 
            
            I=I+1
   88    CONTINUE

C ********************** Generating the rotational matrix ******************  

         TRANS_MATRIX(1,1) = COS(TEMP(1))*COS(TEMP(3))-SIN(TEMP(1))
&                            *TEMP(2)*SIN(TEMP(3))        
         TRANS_MATRIX(1,2) = SIN(TEMP(1))*COS(TEMP(3))+COS(TEMP(1))
&                            *TEMP(2)*SIN(TEMP(3)) 
         TRANS_MATRIX(1,3) = sqrt(1-TEMP(2)**2)*SIN(TEMP(3))
       
         TRANS_MATRIX(2,1) = -COS(TEMP(1))*SIN(TEMP(3))-SIN(TEMP(1))
&                            *TEMP(2)*COS(TEMP(3))
         TRANS_MATRIX(2,2) = -SIN(TEMP(1))*SIN(TEMP(3))+COS(TEMP(1))
&                            *TEMP(2)*COS(TEMP(3))
         TRANS_MATRIX(2,3) = sqrt(1-TEMP(2)**2)*COS(TEMP(3))
        
         TRANS_MATRIX(3,1) = SIN(TEMP(1))*sqrt(1-TEMP(2)**2)
         TRANS_MATRIX(3,2) = -COS(TEMP(1))*sqrt(1-TEMP(2)**2)
         TRANS_MATRIX(3,3) = TEMP(2)
         
      ELSE
         READ(62,*) TRANS_MATRIX(1,1)
         READ(62,*) TRANS_MATRIX(1,2)
         READ(62,*) TRANS_MATRIX(1,3)
         READ(62,*) TRANS_MATRIX(2,1)
         READ(62,*) TRANS_MATRIX(2,2)
         READ(62,*) TRANS_MATRIX(2,3)
         READ(62,*) TRANS_MATRIX(3,1)
         READ(62,*) TRANS_MATRIX(3,2)
         READ(62,*) TRANS_MATRIX(3,3)
      
      END IF
      
C         WRITE(*,*) 'MAIN SONAMONI ....'
C         CALL WRITEMAT(TRANS_MATRIX)
      
         CALL CALCULATE_INVERSE(TRANS_MATRIX,TRANS_MATRIX_INV)
         
C ******************************************************************************
C
C ********* Getting the unit vector in the direction of rotated sigma **********
    
C         DO 100 I=1,30
C            DO 110 J=1,3
C               AL_TEMP(I,J)=AL_START(I,J)
C               AL(I,J)=0
C110         CONTINUE
C100      CONTINUE

         DO 110 J=1,3
               INS_BEAM(J)=0
110         CONTINUE
       
         DO 140 I=1,3
            DO 150 J=1,3
               INS_BEAM(I)= INS_BEAM(I)+
&               TRANS_MATRIX(I,J)*INS_BEAM_ST(J)
150         CONTINUE
140      CONTINUE
  
         CALL DIFFRACTION_PROB(AL_START,INS_BEAM,TRANS_MATRIX,NO_POLES)
  
c         WRITE(*,*) 'SIGMA ',SIGMA(1),SIGMA(2),SIGMA(3)
c         WRITE(*,*) 'SIGMA BEFORE ',SIGMA_TEMP(1),SIGMA_TEMP(2),
c&        SIGMA_TEMP(3)
       
C Increase the number of grain by one !!

        COUNT=COUNT+1   
         
   10 CONTINUE
      
c       WRITE(98,*) 'ONE=',ONE,'TWO=',TWO,'TH=',TH,
c&                   'FOU=',FOU,'FIF=',FIF,'SIX=',SIX
        
   
       DO 160 I=1,18
         J=5+10*(I-1)
         WRITE(96,*) J,COUNT_TRACE(I) 
  160 CONTINUE
  
      CLOSE(RW)   
      CLOSE(RWW)
      CLOSE(RWWW)
      CLOSE(RW_TR)
                
      END
      
C ********************************************************************************** C

      
C ********************************************************************************** C

      SUBROUTINE READING(HABIT,DIRECTION,GM_J_AL,TRANS_MATRIX,
&      NO_POLES,AL_START,AL_TEMP,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,OBS_PLANE,
&      OBS_PLANE_START,COUNT_TRACE,STRESS_TENSOR,SH,DI,TEXTURE,RR)
      
       
      INTEGER DMAX,RH,RD,RJ,RS
      DOUBLE PRECISION PI
      
      PARAMETER (DMAX=24,RH=19,RD=29,RJ=39,RK=49,RL=59,PI=3.14159)
      
      DOUBLE PRECISION HABIT(DMAX,3),DIRECTION(DMAX,3),SIGMA(3)
      DOUBLE PRECISION GM_J_AL(72,3),AL_J_GM(72,3),SIGMA_START(3)
      DOUBLE PRECISION NEW_FERR(72,3),NEW_AUST(72,3),TRANS_MATRIX(3,3)
      DOUBLE PRECISION A,AL_START(30,3),SAMPLE_X(3),SAMPLE_Y(3)
      DOUBLE PRECISION SAMPLE_Z(3),AL_TEMP(30,3)
      DOUBLE PRECISION OBS_PLANE(3),OBS_PLANE_START(3)
      DOUBLE PRECISION STRESS_TENSOR(3,3),SH,DI,TEMP(3)
      INTEGER NO_POLES,FLAG,COUNT_TRACE(18),LOAD,POLE,TEXTURE,RR
      
      FLAG=0
      
c      OPEN(RJ,FILE='sh-vol.txt',STATUS='OLD')
      
c      READ(RJ,*) SH,DI
c      WRITE(*,*) 'SHEAR DEFORMATION: ',SH
c      WRITE(*,*) 'VOLUME DEFORMATION: ',DI
      
c      CLOSE(RJ)
      
c      SH=0.22
c      DI=0.03
      
      OPEN(RH,FILE='habit-other.txt',STATUS='OLD')
      
      DO 10 I=1,DMAX
         READ(RH,*) HABIT(I,1), HABIT(I,2), HABIT(I,3)
   10 CONTINUE
      
      CLOSE(RH)
      
      OPEN(RD,FILE='dis-direction-other.txt',STATUS='OLD')
      
      DO 20 I=1,DMAX
         READ(RD,*) DIRECTION(I,1), DIRECTION(I,2), DIRECTION(I,3)
   20 CONTINUE
   
      CLOSE(RD)
      
      
      OPEN(RK,FILE='gm-j-al-other.txt',STATUS='OLD')
      
      DO 40 I=1,DMAX*3
         READ(RK,*) GM_J_AL(I,1), GM_J_AL(I,2), GM_J_AL(I,3)
   40 CONTINUE
      
      CLOSE(RK)

C ***** GENERATING THE DIRECTION OF STRESS IN THE SAMPLE REFERENCE FRAME          ****************C
C ***** It is important to note that this direction is also one of the directions ****************C
C ***** in the sample reference frame used for drawing the stereogram.            ****************C
C ***** Even if no stress is applied this arbitrary direction is used for drawing ****************C
C ***** the stereogram. This direction can be named as D-X                        ****************C


      I=1
      DO 50 WHILE(I .LE. 3)
            A=RAND()
            SAMPLE_X(I)= A
            I=I+1
   50    CONTINUE
   
      A=(SQRT(SAMPLE_X(1)**2+SAMPLE_X(2)**2
&         +SAMPLE_X(3)**2))

      DO 130 I=1,3
            SAMPLE_X(I)=SAMPLE_X(I)/A
  130 CONTINUE


C ***** GENERATING THE SECOND-DIRECTION IN THE SAMPLE REFERENCE FRAME FOR DRAWING STEREOGRAM ***** C
C ***** This directioon can be named as D-Z.                                                 ***** C

      IF(SAMPLE_X(3) .NE. 0 .AND. FLAG .EQ. 0) THEN  
        WRITE(*,*)'IN 3'
        SAMPLE_Z(1)=2*RAND()-1
        SAMPLE_Z(2)=2*RAND()-1
        SAMPLE_Z(3)=-(SAMPLE_X(1)*SAMPLE_Z(1)+SAMPLE_X(2)*SAMPLE_Z(2))
&            /SAMPLE_X(3)
        FLAG = 1
      END IF
      
      IF(SAMPLE_X(2) .NE. 0 .AND. FLAG .EQ. 0) THEN  
        WRITE(*,*)'IN 2'
        SAMPLE_Z(1)=2*RAND()-1
        SAMPLE_Z(3)=2*RAND()-1
        SAMPLE_Z(2)=-(SAMPLE_X(1)*SAMPLE_Z(1)+SAMPLE_X(3)*SAMPLE_Z(3))
&            /SAMPLE_X(2)
        FLAG = 1
      END IF
      
      IF(SAMPLE_X(1) .NE. 0 .AND. FLAG .EQ. 0) THEN  
        WRITE(*,*)'IN 1'
        SAMPLE_Z(2)=2*RAND()-1
        SAMPLE_Z(3)=2*RAND()-1
        SAMPLE_Z(1)=-(SAMPLE_X(2)*SAMPLE_Z(2)+SAMPLE_X(3)*SAMPLE_Z(3))
&            /SAMPLE_X(1)
        FLAG = 1
      END IF
      
      B=SQRT(SAMPLE_Z(1)**2+SAMPLE_Z(2)**2+SAMPLE_Z(3)**2)
      
      DO 5 I=1,3
         SAMPLE_Z(I)=SAMPLE_Z(I)/B
    5 CONTINUE
C ***********************************************************************************************C


C ***** Generating the third direction in the sample refernce frame for drawing the stereogram ***C
C ***** This direction can be called as D-Y. It is important to note that D-X, D-Y AND D-Z     ***C
C ***** are perpendicular and they are all in the sample reference frame.                          ***C

      CALL CROSS_PROD(SAMPLE_X,SAMPLE_Z,SAMPLE_Y)
       

c      WRITE(*,*) 'FIRST ELEMENT OF THE STRESS TENSOR:'
C      READ(*,*) STRESS_TENSOR(1,1)
      STRESS_TENSOR(1,1)=0.0
      STRESS_TENSOR(1,2)=0.0
      STRESS_TENSOR(1,3)=0.0
      
      STRESS_TENSOR(2,1)=0.0
      STRESS_TENSOR(2,2)=0.0
      STRESS_TENSOR(2,3)=0.0
      
      STRESS_TENSOR(3,1)=0.0
      STRESS_TENSOR(3,2)=0.0
      STRESS_TENSOR(3,3)=0.0
      
      IF(TEXTURE .EQ. 0) THEN
C
C ********* Generating the random number to get rotation axis and angle *******          
C        
         I=1
         DO 81 WHILE(I .LE. 3)
            A=RAND()

            IF(I .NE. 2) THEN
               TEMP(I)=2*PI*A
            ELSE
              TEMP(I)=2*A-1
            END IF 
            
            I=I+1
   81    CONTINUE

C ********************** Generating the rotational matrix ******************  

         TRANS_MATRIX(1,1) = COS(TEMP(1))*COS(TEMP(3))-SIN(TEMP(1))
&                            *TEMP(2)*SIN(TEMP(3))        
         TRANS_MATRIX(1,2) = SIN(TEMP(1))*COS(TEMP(3))+COS(TEMP(1))
&                            *TEMP(2)*SIN(TEMP(3)) 
         TRANS_MATRIX(1,3) = sqrt(1-TEMP(2)**2)*SIN(TEMP(3))
       
         TRANS_MATRIX(2,1) = -COS(TEMP(1))*SIN(TEMP(3))-SIN(TEMP(1))
&                            *TEMP(2)*COS(TEMP(3))
         TRANS_MATRIX(2,2) = -SIN(TEMP(1))*SIN(TEMP(3))+COS(TEMP(1))
&                            *TEMP(2)*COS(TEMP(3))
         TRANS_MATRIX(2,3) = sqrt(1-TEMP(2)**2)*COS(TEMP(3))
        
         TRANS_MATRIX(3,1) = SIN(TEMP(1))*sqrt(1-TEMP(2)**2)
         TRANS_MATRIX(3,2) = -COS(TEMP(1))*sqrt(1-TEMP(2)**2)
         TRANS_MATRIX(3,3) = TEMP(2)
         
      END IF   

      
      IF(TEXTURE .EQ. 1) THEN
        OPEN(RR,FILE='matrix-bias-texture-cu-500.txt',STATUS='OLD')
      ELSE IF(TEXTURE .EQ. 2) THEN
        OPEN(RR,FILE='matrix-bias-texture-brass-500.txt',STATUS='OLD')
      ELSE IF(TEXTURE .EQ. 3) THEN
        OPEN(RR,FILE='matrix-bias-texture-goss-500.txt',STATUS='OLD')
      ELSE IF(TEXTURE .EQ. 4) THEN
        OPEN(RR,FILE='matrix-bias-texture-cube-500.txt',STATUS='OLD')   
      ELSE IF(TEXTURE .EQ. 5) THEN
        OPEN(RR,FILE='matrix-bias-texture-110-111-500.txt',STATUS='OLD')   
      ELSE IF(TEXTURE .EQ. 6) THEN
        OPEN(RR,FILE='matrix-bias-texture-mixture-500.txt',STATUS='OLD') 
      END IF
      
      IF(TEXTURE .NE. 0) THEN
        READ(62,*) TRANS_MATRIX(1,1)
        READ(62,*) TRANS_MATRIX(1,2)
        READ(62,*) TRANS_MATRIX(1,3)
        READ(62,*) TRANS_MATRIX(2,1)
        READ(62,*) TRANS_MATRIX(2,2)
        READ(62,*) TRANS_MATRIX(2,3)
        READ(62,*) TRANS_MATRIX(3,1)
        READ(62,*) TRANS_MATRIX(3,2)
        READ(62,*) TRANS_MATRIX(3,3)
      END IF
      
C      WRITE(*,*) 'KI GO SONAMONI IN READ...'
C      CALL WRITEMAT(TRANS_MATRIX)
      
      SAMPLE_X(1)=1
      SAMPLE_X(2)=0
      SAMPLE_X(3)=0
      
      SAMPLE_Y(1)=0
      SAMPLE_Y(2)=1
      SAMPLE_Y(3)=0
    
      SAMPLE_Z(1)=0
      SAMPLE_Z(2)=0
      SAMPLE_Z(3)=1
      
      
      WRITE(*,*) 'X is',SAMPLE_X(1),SAMPLE_X(2),SAMPLE_X(3)
      WRITE(*,*) 'Y is',SAMPLE_Y(1),SAMPLE_Y(2),SAMPLE_Y(3)
      WRITE(*,*) 'Z is',SAMPLE_Z(1),SAMPLE_Z(2),SAMPLE_Z(3)
      
C ***** ******************************************************************************************C    

      
    
C ***** A SPECIAL CASE WHEN D-X, D-Y, D-Z EXACTLY MATCHES WITH THE X-Y-Z DIRECTION IN ******** C
C ***** THE SAMPLE REFERENCE FRAME.                                                   ******** C

c      SAMPLE_X(1)=1
c      SAMPLE_X(2)=0
c      SAMPLE_X(3)=0

c      SAMPLE_Y(1)=0
c      SAMPLE_Y(2)=1
c      SAMPLE_Y(3)=0
      
c      SAMPLE_Z(1)=0
c      SAMPLE_Z(2)=0
c      SAMPLE_Z(3)=1

C ***************** ******************************************************* ****************** C           
      
          
      OBS_PLANE_START(1)=SAMPLE_Z(1)
      OBS_PLANE_START(2)=SAMPLE_Z(2)
      OBS_PLANE_START(3)=SAMPLE_Z(3)
      
      OBS_PLANE(1)=OBS_PLANE_START(1)
      OBS_PLANE(2)=OBS_PLANE_START(2)
      OBS_PLANE(3)=OBS_PLANE_START(3)
      
      DO 120 I=1,18
         COUNT_TRACE(I)=0
  120 CONTINUE
  
      WRITE(*,*) 'FOR (200) POLE FIG PUT 200 :'
      WRITE(*,*) 'FOR (111) POLE FIG PUT 111 :'
      WRITE(*,*) 'FOR (220) POLE FIG PUT 220 :'
      
      READ(*,*) POLE
c      POLE=111
      DO 140 I=1,30
         DO 150 J=1,3
            AL_START(I,J)=0
150      CONTINUE
140   CONTINUE
   
      IF(POLE .EQ. 200) THEN
        AL_START(1,1)=2
        AL_START(1,2)=0
        AL_START(1,3)=0
        
        AL_START(2,1)=0
        AL_START(2,2)=2
        AL_START(2,3)=0
        
        AL_START(3,1)=0
        AL_START(3,2)=0
        AL_START(3,3)=2
        
        AL_START(4,1)=-2
        AL_START(4,2)=0
        AL_START(4,3)=0
        
        AL_START(5,1)=0
        AL_START(5,2)=-2
        AL_START(5,3)=0
        
        AL_START(6,1)=0
        AL_START(6,2)=0
        AL_START(6,3)=-2
        
        NO_POLES=6
        
        WRITE(*,*) 'NUMBER OF POLES:',NO_POLES
        
        
      ELSE IF(POLE .EQ. 111) THEN
        AL_START(1,1)=1
        AL_START(1,2)=1
        AL_START(1,3)=1
        
        AL_START(2,1)=-1
        AL_START(2,2)=-1
        AL_START(2,3)=-1
        
        AL_START(3,1)=-1
        AL_START(3,2)=-1
        AL_START(3,3)=1
        
        AL_START(4,1)=1
        AL_START(4,2)=-1
        AL_START(4,3)=-1
        
        AL_START(5,1)=-1
        AL_START(5,2)=1
        AL_START(5,3)=-1
        
        AL_START(6,1)=1
        AL_START(6,2)=-1
        AL_START(6,3)=1
        
        AL_START(7,1)=1
        AL_START(7,2)=1
        AL_START(7,3)=-1
        
        AL_START(8,1)=-1
        AL_START(8,2)=1
        AL_START(8,3)=1      
        
        NO_POLES=8
         
        WRITE(*,*) 'NUMBER OF POLES:',NO_POLES
        
        
      ELSE IF(POLE .EQ. 220) THEN
      
        AL_START(1,1)=2
        AL_START(1,2)=2
        AL_START(1,3)=0
        
        AL_START(2,1)=-2
        AL_START(2,2)=2
        AL_START(2,3)=0
        
        AL_START(3,1)=2
        AL_START(3,2)=-2
        AL_START(3,3)=0
        
        AL_START(4,1)=-2
        AL_START(4,2)=-2
        AL_START(4,3)=0
        
        AL_START(5,1)=2
        AL_START(5,2)=0
        AL_START(5,3)=2
        
        AL_START(6,1)=-2
        AL_START(6,2)=0
        AL_START(6,3)=2
        
        AL_START(7,1)=2
        AL_START(7,2)=0
        AL_START(7,3)=-2
        
        AL_START(8,1)=-2
        AL_START(8,2)=0
        AL_START(8,3)=-2
        
        AL_START(9,1)=0
        AL_START(9,2)=-2
        AL_START(9,3)=-2
        
        AL_START(10,1)=0
        AL_START(10,2)=2
        AL_START(10,3)=2
        
        AL_START(11,1)=0
        AL_START(11,2)=-2
        AL_START(11,3)=2
        
        AL_START(12,1)=0
        AL_START(12,2)=2
        AL_START(12,3)=-2
        
        NO_POLES=12
        
        WRITE(*,*) 'NUMBER OF POLES:',NO_POLES
                
      END IF
      
      DO 160 I=1,30
         DO 170 J=1,3
            AL_TEMP(I,J)=AL_START(I,J)
170      CONTINUE
160   CONTINUE
      	
      END
      
C ********************************************************************************** C  

C ********************************************************************************** C
      SUBROUTINE CAL_THETA(P,SIGMA,THETA,I)
     
      INTEGER DMAX
      
      PARAMETER (DMAX=24,PI=3.141592654)
      
      INTEGER I,J
      DOUBLE PRECISION P(3),SIGMA(3),THETA(DMAX),A

      
      A = 0.0
    
C      WRITE(*,*) 'SIGMA',SIGMA(1),SIGMA(2),SIGMA(3) 

      DO 20 J=1,3
          A = A + P(J) * SIGMA(J)
20    CONTINUE
     
      
      IF (A .GT. 1.0) THEN
         A=1.0
      ELSE IF(A .LT. -1.0) THEN
         A=-1.0
      END IF
      
      THETA(I)=ACOS(A)
    
      END
     
C ********************************************************************************* C

C ********************************************************************************** C 

      SUBROUTINE CROSS_PROD(X,Y,Z)
      
      INTEGER DMAX
      
      PARAMETER(DMAX=24)
      
      DOUBLE PRECISION X(3),Y(3),Z(3),TEMP
      INTEGER I
      
      Z(1) = X(2)*Y(3) - X(3)*Y(2)
      Z(2) = -1 * (X(1)*Y(3) - X(3)*Y(1))
      Z(3) = X(1)*Y(2) - X(2)*Y(1)
      
      TEMP = SQRT(Z(1)**2 + Z(2)**2 + Z(3)**2)
      
      Z(1)=Z(1)/TEMP
      Z(2)=Z(2)/TEMP
      Z(3)=Z(3)/TEMP
      
C      WRITE(*,*) 'THE VALUE OF K ARE', K(1), K(2), K(3)
      
      END

C ********************************************************************************** C 
   
C ********************************************************************************* C

      SUBROUTINE CRAMER(T,X,Y,Z,Q)
      
      DOUBLE PRECISION T(3),X(3),Y(3),Z(3),Q(3)
      INTEGER I,J
      DOUBLE PRECISION TEMPO(3,3),EQU(3,3)
      DOUBLE PRECISION DETER_EQU,DETER_TEMP
      
      DO 10 J=1,3
         EQU(1,J)=X(J)
         TEMPO(1,J)=X(J)
         EQU(2,J)=Y(J)
         TEMPO(2,J)=Y(J)
         EQU(3,J)=Z(J)
         TEMPO(3,J)=Z(J)
   10 CONTINUE
   
      DETER_EQU=EQU(1,1)*(EQU(2,2)*EQU(3,3) - EQU(2,3)*EQU(3,2))
&     +EQU(1,2)*(EQU(2,3)*EQU(3,1) - EQU(2,1)*EQU(3,3))
&     +EQU(1,3)*(EQU(2,1)*EQU(3,2) - EQU(2,2)*EQU(3,1))
              
      DO 20 I=1,3
         DO 30 J=1,3
            TEMPO(J,I)=Q(J)
   30    CONTINUE   
   
         DETER_TEMP=TEMPO(1,1)*(TEMPO(2,2)*TEMPO(3,3)-
&        TEMPO(2,3)*TEMPO(3,2))
&        +TEMPO(1,2)*(TEMPO(2,3)*TEMPO(3,1) - 
&        TEMPO(2,1)*TEMPO(3,3))
&        +TEMPO(1,3)*(TEMPO(2,1)*TEMPO(3,2) 
&        - TEMPO(2,2)*TEMPO(3,1))
                 
         T(I)=DETER_TEMP/DETER_EQU
         
         DO 40 J=1,3
            TEMPO(J,I)=EQU(J,I)
   40    CONTINUE  
   20 CONTINUE
   
      END
      
C ********************************************************************************* C

C ********************************************************************************* C

      SUBROUTINE CALCULATE_PHI(X,Y,PHI,I)
      
      DOUBLE PRECISION X(3),Y(3),PHI(24)
      INTEGER I
         
      PHI(I) = (X(1) * Y(1) + X(2) * Y(2) + X(3) * Y(3))
      
      IF(PHI(I) > 1) THEN
        PHI(I) = 1;
      ENDIF
      
      IF(PHI(I) < -1) THEN
        PHI(I) = -1;
      ENDIF
        
      PHI(I) = ACOS(PHI(I));
      
      END
      
C ********************************************************************************* C


C ********************************************************************************* C

       SUBROUTINE CALCULATE_MECH_ENG(X,Y,BETA,U,I,STRESS,SH,DI)
      
       DOUBLE PRECISION X(24),Y(24),U(24),STRESS,TAO,SIG
       DOUBLE PRECISION BETA,SH,DI,stress_lo
       INTEGER I

       SIG=DI*STRESS*COS(X(I))
      
       IF(X(I) .NE. 0) THEN    
        TAO=SH*STRESS*COS(BETA)*COS(Y(I))
       ELSE
         TAO=0.0
       END IF
      
       U(I)=TAO+SIG
     
c      WRITE(*,909) TAO,SIG,I
c909   format('shear, normal, variant',2f10.4,i5)
  
       RETURN   
      
       END  
      
C ********************************************************************************* C

C ********************************************************************************* C

      SUBROUTINE SORTING(X,Y,Z,ALL_INFO)
      
      DOUBLE PRECISION X(24),Y(24),Z(24),ALL_INFO(24,4)
      INTEGER I,J
      DOUBLE PRECISION TEMPA,TEMPB,TEMPC,TEMPD
      
      DO 10 I=1,24
         ALL_INFO(I,1) = I
         ALL_INFO(I,2) = X(I)
         ALL_INFO(I,3) = Y(I)
         ALL_INFO(I,4) = Z(I)
   10 CONTINUE
   
      DO 20 I=1,24
         J=I
         DO 30 WHILE(J .LE. 24)
            IF(ALL_INFO(I,4) .LT. ALL_INFO(J,4)) THEN
            
              TEMPA=ALL_INFO(I,1)
              ALL_INFO(I,1)=ALL_INFO(J,1)
              ALL_INFO(J,1)=TEMPA
              
              TEMPB=ALL_INFO(I,2)
              ALL_INFO(I,2)=ALL_INFO(J,2)
              ALL_INFO(J,2)=TEMPB
              
              TEMPC=ALL_INFO(I,3)
              ALL_INFO(I,3)=ALL_INFO(J,3)
              ALL_INFO(J,3)=TEMPC
              
              TEMPD=ALL_INFO(I,4)
              ALL_INFO(I,4)=ALL_INFO(J,4)
              ALL_INFO(J,4)=TEMPD          
              J=I
            ELSE
              J=J+1
            ENDIF
            
   30    CONTINUE
   20 CONTINUE
   
      END
      
C **************************************************************************** C

C **************************************************************************** C   


      SUBROUTINE WRITING(X)
      
      DOUBLE PRECISION PI
      
      PARAMETER(PI=3.141592654)
      
      DOUBLE PRECISION X(24,4)
      INTEGER I
      
      DO 10 I=1,24
         WRITE(*,*) I,' VAR=',X(I,1),' THE=',X(I,2)*180/PI,' PH='
&         ,X(I,3)*180/PI,' U=',X(I,4)
   10 CONTINUE
c      WRITE(*,*) ''
   
      END
   
C **************************************************************************** C   
      
C **************************************************************************** C
                                                                                
      SUBROUTINE GET_XY(V,GM_J_AL,X_ST,Y_ST,AL,TRANS_MATRIX,NO_POLES,
&     GM_CONV_TEMP,GM_CONV,CRYSTAL,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,
&     TRANS_MATRIX_INVERSE)


      
      DOUBLE PRECISION PI
      
      PARAMETER (PI=3.141592654)
      
      DOUBLE PRECISION GM_J_AL(72,3),GM_CONV(30,3),AL(30,3),X_ST,Y_ST
      DOUBLE PRECISION Z,COS_THETAS,THETAS,GM_CONV_TEMP(30,3)
      DOUBLE PRECISION COS_ALPHAS,ALPHAS,TEMP,IDEN_MAT(3,3)
      DOUBLE PRECISION TRANS_MATRIX_INVERSE(3,3),ALPHASS
      DOUBLE PRECISION V,NO,RADIOUS,TRANS_MATRIX(3,3),COS_ALPHASS
      DOUBLE PRECISION ALPHA_NEW,H,K,L,A,P,Q,R,DIA(3)
      DOUBLE PRECISION SAMPLE_X(3),SAMPLE_Y(3),SAMPLE_Z(3)
      INTEGER NO_POLES,TAG_HERE
      REAL BIG
      
      TAG_HERE=1
      IDEN_MAT(1,1)=1
      IDEN_MAT(1,2)=0
      IDEN_MAT(1,3)=0
      IDEN_MAT(2,1)=0
      IDEN_MAT(2,2)=1
      IDEN_MAT(2,3)=0
      IDEN_MAT(3,1)=0
      IDEN_MAT(3,2)=0
      IDEN_MAT(3,3)=1

      DO 100 I=1,NO_POLES 
         DO 110 J=1,3
             GM_CONV(I,J)=0  
             GM_CONV_TEMP(I,J)=0
  110    CONTINUE
  100 CONTINUE
  
      DO 410 I=1,3
c           WRITE(*,*) TRANS_MATRIX(I,1), TRANS_MATRIX(I,2)
c&            , TRANS_MATRIX(I,3)
  410 CONTINUE
  
      RADIOUS=4
      
      NO=1+(V-1)*3
C PLEASE BE CAREFUL: You can either plot ferrite poles or austenite poles not both together ******   
	  DO 10 I=1,NO_POLES
         DO 20 K=1,3
            DO 30 L=1,3
               IF(CRYSTAL .EQ. 1) THEN
C *************************** Plotting ferrite poles ***************************
                 GM_CONV(I,K)=GM_CONV(I,K) + GM_J_AL(NO+(K-1),L)*AL(I,L)
C ******************************************************************************
               ELSE IF(CRYSTAL .EQ. 0) THEN
C *************************** Plotting austenite poles *************************
                  GM_CONV(I,K)=GM_CONV(I,K) + IDEN_MAT(K,L)*AL(I,L)
C ******************************************************************************
               END IF
   30       CONTINUE
   20    CONTINUE 

c       WRITE(*,*) 'gm_conv',SQRT(GM_CONV(I,1)**2+GM_CONV(I,2)**2
c&       +GM_CONV(I,3)**2)

      DO 40 S=1,3
         GM_CONV_TEMP(I,S)=0
   40 CONTINUE
      
C      CALL CALCULATE_INVERSE(TRANS_MATRIX,TRANS_MATRIX_INVERSE)
   
      DO 50 S=1,3
         GM_CONV_TEMP(I,S)=
&         TRANS_MATRIX_INVERSE(S,1)*GM_CONV(I,1) 
&         + TRANS_MATRIX_INVERSE(S,2)*GM_CONV(I,2) + 
&          TRANS_MATRIX_INVERSE(S,3)*GM_CONV(I,3)
   50 CONTINUE
      
      DO 60 S =1,3
        GM_CONV(I,S)=GM_CONV_TEMP(I,S)
   60 CONTINUE
       
c      WRITE(*,*) 'gm_conv-ran',GM_CONV(I,1),GM_CONV(I,2),
c&      GM_CONV(I,3)


C ** Multiplying converted gamma pole with D-Z to have the angle theta and the z value **   
      
      COS_THETAS=(SAMPLE_Z(1)*GM_CONV(I,1)+SAMPLE_Z(2)*GM_CONV(I,2)
&     +SAMPLE_Z(3)*GM_CONV(I,3))
&     /(SQRT(GM_CONV(I,1)**2+GM_CONV(I,2)**2+GM_CONV(I,3)**2))

          
      THETAS=ACOS(COS_THETAS)
      
      IF(THETAS .GT. PI/2 .AND. THETAS .LE. PI) THEN
        THETAS=PI-THETAS
        TAG_HERE=0
      ELSE IF(THETAS .GE. 0 .AND. THETAS .LE. PI/2) THEN
        THETAS=THETAS
        TAG_HERE=1
      END IF
        
c      WRITE(*,*) 'THETA', THETAS*180/PI,COS_THETAS,
c&     GM_CONV(I,1),GM_CONV(I,2),GM_CONV(I,3)     

      Z=RADIOUS*TAN(THETAS/2)

C ***************************************************************************************     

C ***** Multiplying converted alpha pole (hkl) with D-X to have the angle alpha *********

      DIA(1)=0
      DIA(1)=0
      DIA(3)=0
      
      A=(SQRT(GM_CONV(I,1)**2+GM_CONV(I,2)**2+GM_CONV(I,3)**2))
      
      P=GM_CONV(I,1)/A
      Q=GM_CONV(I,2)/A
      R=GM_CONV(I,3)/A
      
      IF(TAG_HERE .EQ. 1) THEN
        DIA(1)=4*(P+SAMPLE_Z(1))
        DIA(2)=4*(Q+SAMPLE_Z(2))
        DIA(3)=4*(R+SAMPLE_Z(3))
      ELSE
        DIA(1)=4*(P-SAMPLE_Z(1))
        DIA(2)=4*(Q-SAMPLE_Z(2))
        DIA(3)=4*(R-SAMPLE_Z(3))
      END IF
      
      A=SQRT(DIA(1)**2+DIA(2)**2+DIA(3)**2)
      
      DIA(1)=DIA(1)/A
      DIA(2)=DIA(2)/A
      DIA(3)=DIA(3)/A

      H=4*P-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(1)

      K=4*Q-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(2)

      L=4*R-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(3)
      
      A=SQRT(H**2+K**2+L**2)
      H=H/A
      K=K/A
      L=L/A
      
      COS_ALPHAS=((H*SAMPLE_X(1))+(K*SAMPLE_X(2))+(L*SAMPLE_X(3)))

      ALPHAS=ACOS(COS_ALPHAS)
      
      COS_ALPHASS=((H*SAMPLE_Y(1))+(K*SAMPLE_Y(2))+(L*SAMPLE_Y(3)))

      ALPHASS=ACOS(COS_ALPHASS)
      
      IF(ALPHAS .GE. PI/2) THEN
        ALPHA_NEW=PI-ALPHAS
      ELSE
        ALPHA_NEW=ALPHAS
      END IF
      

      IF(ALPHAS .GE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
        ALPHA_NEW=PI+ALPHA_NEW
      ELSE IF(ALPHAS .GE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
        ALPHA_NEW=PI-ALPHA_NEW
      ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
        ALPHA_NEW=ALPHA_NEW
      ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
        ALPHA_NEW=2*PI-ALPHA_NEW
      END IF
      
C      WRITE(*,*) 'ALPHA', ALPHA_NEW*180/PI
      
      
C ******************************************************************************    

C ********* Sort out which quardrant the point is falling in *******************

CC      IF(GM_CONV(I,1) .LE. 0 .AND. GM_CONV(I,2) .LE. 0) THEN
C         ALPHAS=PI-ALPHAS+PI
C      ELSE IF(GM_CONV(I,1) .GE. 0 .AND. GM_CONV(I,2) .LE. 0) THEN
C         ALPHAS=2*PI-ALPHAS
C      END IF
C ******************************************************************************

      

C ******************** Get the X-Y co-ordinates ********************************

      IF(GM_CONV(I,1) .EQ. 0 .AND. GM_CONV(I,2) .EQ. 0) THEN
          X_ST=0
          Y_ST=0
      ELSE
          X_ST=Z*COS(ALPHA_NEW)
          Y_ST=Z*SIN(ALPHA_NEW)
      END IF
      
C ******************************************************************************      
      WRITE(99,*) X_ST, Y_ST,V
      
   10 CONTINUE
      
      END
      
      
C ******************************End Subroutine *********************************   

C **************************************************************************** C
                                                                                
      SUBROUTINE GET_XY_HABIT(V,GM_J_AL,X_ST,Y_ST,AL,
&               TRANS_MATRIX,NO_POLES,GM_CONV_HABIT_TEMP,
&              GM_CONV_HABIT,SAMPLE_X,SAMPLE_Y,SAMPLE_Z,
&               TRANS_MATRIX_INVERSE)
      
      DOUBLE PRECISION PI
      
      PARAMETER (PI=3.141592654)
      
      DOUBLE PRECISION GM_J_AL(72,3),GM_CONV_HABIT(30,3),AL(24,3),X_ST
      DOUBLE PRECISION Z,COS_THETAS,THETAS,GM_CONV_HABIT_TEMP(30,3)
      DOUBLE PRECISION COS_ALPHAS,ALPHAS,TEMP,IDEN_MAT(3,3)
      DOUBLE PRECISION TRANS_MATRIX_INVERSE(3,3),Y_ST
      DOUBLE PRECISION V,NO,RADIOUS,TRANS_MATRIX(3,3),DIA(3)
      DOUBLE PRECISION SAMPLE_X(3),SAMPLE_Y(3),SAMPLE_Z(3)
      DOUBLE PRECISION H,K,L
      INTEGER NO_POLES
      
      IDEN_MAT(1,1)=1
      IDEN_MAT(1,2)=0
      IDEN_MAT(1,3)=0
      IDEN_MAT(2,1)=0
      IDEN_MAT(2,2)=1
      IDEN_MAT(2,3)=0
      IDEN_MAT(3,1)=0
      IDEN_MAT(3,2)=0
      IDEN_MAT(3,3)=1

      DO 100 I=1,30
         DO 110 J=1,3
             GM_CONV_HABIT(I,J)=0  
             GM_CONV_HABIT_TEMP(I,J)=0
C             WRITE(*,*) 'CONV= ',GM_CONV_HABIT(I,1), GM_CONV_HABIT(I,2), 
C&      GM_CONV_HABIT(I,3)
  
  110    CONTINUE
  100 CONTINUE
  
      
c      DO 410 I=1,3
c           WRITE(*,*) TRANS_MATRIX(I,1), TRANS_MATRIX(I,2)
c&            , TRANS_MATRIX(I,3)
c  410 CONTINUE
  
      RADIOUS=4
      
C      NO_POLES=V
C PLEASE BE CAREFUL: You can either plot ferrite poles or austenite poles not both together ****** 

	  DO 10 I=1,NO_POLES
         DO 20 K=1,3
            DO 30 L=1,3
C *************************** Plotting HABIT poles *************************
               GM_CONV_HABIT(I,K)=GM_CONV_HABIT(I,K) + 
&               IDEN_MAT(K,L)*AL(V,L)
C ******************************************************************************
   30       CONTINUE
   20    CONTINUE 
     
C      WRITE(*,*) 'CONV MUL= ',GM_CONV_HABIT(I,1), GM_CONV_HABIT(I,2), 
C&      GM_CONV_HABIT(I,3),V

      DO 40 S=1,3
         GM_CONV_HABIT_TEMP(I,S)=0
   40 CONTINUE
      
C      CALL CALCULATE_INVERSE(TRANS_MATRIX,TRANS_MATRIX_INVERSE)
   
      DO 50 S=1,3
         GM_CONV_HABIT_TEMP(I,S)=
&         TRANS_MATRIX_INVERSE(S,1)*GM_CONV_HABIT(I,1) 
&         + TRANS_MATRIX_INVERSE(S,2)*GM_CONV_HABIT(I,2) + 
&          TRANS_MATRIX_INVERSE(S,3)*GM_CONV_HABIT(I,3)
   50 CONTINUE
      
      DO 60 S =1,3
        GM_CONV_HABIT(I,S)=GM_CONV_HABIT_TEMP(I,S)
   60 CONTINUE
      
C      WRITE(*,*) 'CONV MUL-rot= ',GM_CONV_HABIT(I,1),GM_CONV_HABIT(I,2), 
C&      GM_CONV_HABIT(I,3)
         

C ** Multiplying converted gamma pole with D-Z to have the angle theta and the z value **   
      
      COS_THETAS=(SAMPLE_Z(1)*GM_CONV_HABIT(I,1)
&      +SAMPLE_Z(2)*GM_CONV_HABIT(I,2)
&     +SAMPLE_Z(3)*GM_CONV_HABIT(I,3))
&     /(SQRT(GM_CONV_HABIT(I,1)**2+GM_CONV_HABIT(I,2)**2
&      +GM_CONV_HABIT(I,3)**2))

          
      THETAS=ACOS(COS_THETAS)
      
      IF(THETAS .GT. PI/2 .AND. THETAS .LE. PI) THEN
        THETAS=PI-THETAS
        TAG_HERE=0
      ELSE IF(THETAS .GE. 0 .AND. THETAS .LE. PI/2) THEN
        THETAS=THETAS
        TAG_HERE=1
      END IF
        
C      WRITE(*,*) 'THETA', THETAS*180/PI


      Z=RADIOUS*TAN(THETAS/2)

C ***************************************************************************************     

C ***** Multiplying converted alpha pole (hkl) with D-X to have the angle alpha *********

      DIA(1)=0
      DIA(1)=0
      DIA(3)=0
      
      A=(SQRT(GM_CONV_HABIT(I,1)**2+GM_CONV_HABIT(I,2)**2
&      +GM_CONV_HABIT(I,3)**2))

C      WRITE(*,*) 'A=',A
      
      P=GM_CONV_HABIT(I,1)/A
      Q=GM_CONV_HABIT(I,2)/A
      R=GM_CONV_HABIT(I,3)/A
      
      IF(TAG_HERE .EQ. 1) THEN
        DIA(1)=4*(P+SAMPLE_Z(1))
        DIA(2)=4*(Q+SAMPLE_Z(2))
        DIA(3)=4*(R+SAMPLE_Z(3))
      ELSE
        DIA(1)=4*(P-SAMPLE_Z(1))
        DIA(2)=4*(Q-SAMPLE_Z(2))
        DIA(3)=4*(R-SAMPLE_Z(3))
      END IF
      
      A=SQRT(DIA(1)**2+DIA(2)**2+DIA(3)**2)
      
      DIA(1)=DIA(1)/A
      DIA(2)=DIA(2)/A
      DIA(3)=DIA(3)/A
      
C      WRITE(*,*) 'DIA=',DIA(1),DIA(2),DIA(3)
      
      H=4*P-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(1)

      K=4*Q-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(2)

      L=4*R-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(3)

      A=SQRT(H**2+K**2+L**2)
      H=H/A
      K=K/A
      L=L/A
C      WRITE(*,*) 'H',H,K,L
      COS_ALPHAS=((H*SAMPLE_X(1))+(K*SAMPLE_X(2))+(L*SAMPLE_X(3)))

      ALPHAS=ACOS(COS_ALPHAS)
      
      COS_ALPHASS=((H*SAMPLE_Y(1))+(K*SAMPLE_Y(2))+(L*SAMPLE_Y(3)))

      ALPHASS=ACOS(COS_ALPHASS)
      
      IF(ALPHAS .GE. PI/2) THEN
        ALPHA_NEW=PI-ALPHAS
      ELSE
        ALPHA_NEW=ALPHAS
      END IF
      

      IF(ALPHAS .GE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
        ALPHA_NEW=PI+ALPHA_NEW
      ELSE IF(ALPHAS .GE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
        ALPHA_NEW=PI-ALPHA_NEW
      ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
        ALPHA_NEW=ALPHA_NEW
      ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
        ALPHA_NEW=2*PI-ALPHA_NEW
      END IF
      
C      WRITE(*,*) 'ALPHA', ALPHA_NEW*180/PI
      
      
C ******************************************************************************    

C ********* Sort out which quardrant the point is falling in *******************

CC      IF(GM_CONV(I,1) .LE. 0 .AND. GM_CONV(I,2) .LE. 0) THEN
C         ALPHAS=PI-ALPHAS+PI
C      ELSE IF(GM_CONV(I,1) .GE. 0 .AND. GM_CONV(I,2) .LE. 0) THEN
C         ALPHAS=2*PI-ALPHAS
C      END IF
C ******************************************************************************

      

C ******************** Get the X-Y co-ordinates ********************************

      IF(GM_CONV_HABIT(I,1) .EQ. 0 .AND. GM_CONV_HABIT(I,2) .EQ. 0) THEN
          X_ST=0
          Y_ST=0
      ELSE
          X_ST=Z*COS(ALPHA_NEW)
          Y_ST=Z*SIN(ALPHA_NEW)
      END IF
      
C ******************************************************************************      
      WRITE(97,*) X_ST, Y_ST
      
   10 CONTINUE
      
      END
      
C ******************************End Subroutine *********************************     

C ******************** This subroutine calculates the inverse of a matrix ******

      SUBROUTINE GET_TRACE_ON_HABIT(V,HABIT,OBS_PLANE,SIGMA,
&                COUNT_TRACE)
      
      PARAMETER (PI=3.141592654)
      
      INTEGER I,J,COUNT_TRACE(18)
      DOUBLE PRECISION HABIT(24,3),OBS_PLANE(3),SIGMA(3)
      DOUBLE PRECISION NORMAL(3),TEMP,ANGLE_TRACE,V
      
      
      NORMAL(1) = HABIT(V,2)*OBS_PLANE(3) - HABIT(V,3)*OBS_PLANE(2)
      NORMAL(2) = -1 * (HABIT(V,1)*OBS_PLANE(3) - 
&                 HABIT(V,3)*OBS_PLANE(1))
      NORMAL(3) = HABIT(V,1)*OBS_PLANE(2) - 
&                 HABIT(V,2)*OBS_PLANE(1)
      
      TEMP=SQRT(NORMAL(1)**2+NORMAL(2)**2+NORMAL(3)**2)
      
      NORMAL(1)=NORMAL(1)/TEMP
      NORMAL(2)=NORMAL(2)/TEMP
      NORMAL(3)=NORMAL(3)/TEMP
      
      ANGLE_TRACE=ACOS(NORMAL(1)*SIGMA(1)+NORMAL(2)*SIGMA(2)
&      +NORMAL(3)*SIGMA(3))
      
      IF(ANGLE_TRACE .GT. PI/2) THEN
c        ANGLE_TRACE=PI-ANGLE_TRACE
      END IF
      
      ANGLE_TRACE=(180/PI)*ANGLE_TRACE
      
C      WRITE(*,*) 'TRACE ANGLE',V,ANGLE_TRACE
C      write(*,*) 'OBS',OBS_PLANE(1),OBS_PLANE(2),OBS_PLANE(3)
C      write(*,*) 'HABIT',HABIT(V,1),HABIT(V,2),HABIT(V,3)
      
      
      IF(ANGLE_TRACE .GT. 0 .AND. ANGLE_TRACE .LE. 10) THEN
        COUNT_TRACE(1)=COUNT_TRACE(1)+1
      ELSE IF(ANGLE_TRACE .GT. 10 .AND. ANGLE_TRACE .LE. 20) THEN
        COUNT_TRACE(2)=COUNT_TRACE(2)+1
      ELSE IF(ANGLE_TRACE .GT. 20 .AND. ANGLE_TRACE .LE. 30) THEN
        COUNT_TRACE(3)=COUNT_TRACE(3)+1
      ELSE IF(ANGLE_TRACE .GT. 30 .AND. ANGLE_TRACE .LE. 40) THEN
        COUNT_TRACE(4)=COUNT_TRACE(4)+1
      ELSE IF(ANGLE_TRACE .GT. 40 .AND. ANGLE_TRACE .LE. 50) THEN
        COUNT_TRACE(5)=COUNT_TRACE(5)+1
      ELSE IF(ANGLE_TRACE .GT. 50 .AND. ANGLE_TRACE .LE. 60) THEN
        COUNT_TRACE(6)=COUNT_TRACE(6)+1
      ELSE IF(ANGLE_TRACE .GT. 60 .AND. ANGLE_TRACE .LE. 70) THEN
        COUNT_TRACE(7)=COUNT_TRACE(7)+1
      ELSE IF(ANGLE_TRACE .GT. 70 .AND. ANGLE_TRACE .LE. 80) THEN
        COUNT_TRACE(8)=COUNT_TRACE(8)+1
      ELSE IF(ANGLE_TRACE .GT. 80 .AND. ANGLE_TRACE .LE. 90) THEN
        COUNT_TRACE(9)=COUNT_TRACE(9)+1
       ELSE IF(ANGLE_TRACE .GT. 90 .AND. ANGLE_TRACE .LE. 100) THEN
        COUNT_TRACE(10)=COUNT_TRACE(10)+1
      ELSE IF(ANGLE_TRACE .GT. 100 .AND. ANGLE_TRACE .LE. 110) THEN
        COUNT_TRACE(11)=COUNT_TRACE(11)+1
      ELSE IF(ANGLE_TRACE .GT. 110 .AND. ANGLE_TRACE .LE. 120) THEN
        COUNT_TRACE(12)=COUNT_TRACE(12)+1
      ELSE IF(ANGLE_TRACE .GT. 120 .AND. ANGLE_TRACE .LE. 130) THEN
        COUNT_TRACE(13)=COUNT_TRACE(13)+1
      ELSE IF(ANGLE_TRACE .GT. 130 .AND. ANGLE_TRACE .LE. 140) THEN
        COUNT_TRACE(14)=COUNT_TRACE(14)+1
      ELSE IF(ANGLE_TRACE .GT. 140 .AND. ANGLE_TRACE .LE. 150) THEN
        COUNT_TRACE(15)=COUNT_TRACE(15)+1
      ELSE IF(ANGLE_TRACE .GT. 150 .AND. ANGLE_TRACE .LE. 160) THEN
        COUNT_TRACE(16)=COUNT_TRACE(16)+1
      ELSE IF(ANGLE_TRACE .GT. 160 .AND. ANGLE_TRACE .LE. 170) THEN
        COUNT_TRACE(17)=COUNT_TRACE(17)+1
      ELSE IF(ANGLE_TRACE .GT. 170 .AND. ANGLE_TRACE .LE. 180) THEN
        COUNT_TRACE(18)=COUNT_TRACE(18)+1
      
      END IF
      
      END
      
C ******************************End Subroutine *********************************   

      
C ******************** This subroutine calculates the inverse of a matrix ******

      SUBROUTINE CALCULATE_INVERSE(TATA,MAT_INV)   
      
      INTEGER I,J
      DOUBLE PRECISION DET,TATA(3,3)
      DOUBLE PRECISION MAT_INV(3,3)
      
      DET=TATA(1,1)*(TATA(2,2)*TATA(3,3)-TATA(2,3)*TATA(3,2))
&         -TATA(1,2)*(TATA(2,1)*TATA(3,3)-TATA(2,3)*TATA(3,1))
&         +TATA(1,3)*(TATA(2,1)*TATA(3,2)-TATA(2,2)*TATA(3,1))

      DO 10 I=1,3
         DO 20 J=1,3
            MAT_INV(I,J)=0
   20    CONTINUE
   10 CONTINUE

      MAT_INV(1,1)=(TATA(2,2)*TATA(3,3)-TATA(2,3)*TATA(3,2))/DET
      MAT_INV(1,2)=(TATA(3,2)*TATA(1,3)-TATA(3,3)*TATA(1,2))/DET
      MAT_INV(1,3)=(TATA(1,2)*TATA(2,3)-TATA(1,3)*TATA(2,2))/DET
      
      MAT_INV(2,1)=(TATA(2,3)*TATA(3,1)-TATA(2,1)*TATA(3,3))/DET
      MAT_INV(2,2)=(TATA(3,3)*TATA(1,1)-TATA(3,1)*TATA(1,3))/DET
      MAT_INV(2,3)=(TATA(1,3)*TATA(2,1)-TATA(1,1)*TATA(2,3))/DET
      
      MAT_INV(3,1)=(TATA(2,1)*TATA(3,2)-TATA(2,2)*TATA(3,1))/DET
      MAT_INV(3,2)=(TATA(3,1)*TATA(1,2)-TATA(3,2)*TATA(1,1))/DET
      MAT_INV(3,3)=(TATA(1,1)*TATA(2,2)-TATA(1,2)*TATA(2,1))/DET
      
      END
      
C ******************************End Subroutine *********************************    

C ************************ This is a subroutine ********************************

      SUBROUTINE CAL_DEFMAT(TRANS_MATRIX,TRANS_MATRIX_INV,
&                 STRESS_TENSOR,DEF_MAT)
                 
      DOUBLE PRECISION TRANS_MATRIX(3,3),TRANS_MATRIX_INV(3,3)
      DOUBLE PRECISION DEF_MAT(3,3),STRESS_TENSOR(3,3),TEMP(3,3)
      INTEGER H
      
      
      CALL MAT_MUL(TEMP,TRANS_MATRIX,STRESS_TENSOR)
      CALL MAT_MUL(DEF_MAT,TEMP,TRANS_MATRIX_INV)
      
c      call writemat(TRANS_MATRIX)
c      call writemat(stress_tensor)   
c      call writemat(Trans_matrix_transp)
C      call writemat(DEF_MAT)
      
      RETURN
      
      END

C ******************************End Subroutine *********************************    

      SUBROUTINE TENSOR_CALC(SIGMA,DEF_MAT,P,STRESS)      
      
      DOUBLE PRECISION SIGMA(3),DEF_MAT(3,3),P(3),STRESS
      DOUBLE PRECISION A
      INTEGER G,I,J,H
      
      SIGMA(1)=0.0
      SIGMA(2)=0.0
      SIGMA(3)=0.0
      
      DO 10 I=1,3
         DO 20 J=1,3
            SIGMA(I)=SIGMA(I)+DEF_MAT(I,J)*P(J)
20       CONTINUE
10    CONTINUE

      A=DSQRT(SIGMA(1)**2+SIGMA(2)**2+SIGMA(3)**2)
      
      STRESS=A
      
      DO 30 I=1,3
         SIGMA(I)=SIGMA(I)/A
30    CONTINUE
      
      IF(STRESS .EQ. 0) THEN
         SIGMA(1)=1
         SIGMA(2)=0
         SIGMA(3)=0
      END IF
      
C      WRITE(*,*) 'SIG',SIGMA(1),SIGMA(2),SIGMA(3),STRESS
C      DO 15 H=1,3
C            WRITE(*,995) DEF_MAT(H,1),DEF_MAT(H,2),DEF_MAT(H,3)
C995         FORMAT('SS',3D20.10)
C15      CONTINUE
C      WRITE(*,*) 'HABIT',HABIT(G,1),HABIT(G,2),HABIT(G,3)
      
C      STOP
       
      
      END
      
      
C----------------------------------------------------------------
C To evaluate the product A  of two 3x3 matrices B and C
C
      SUBROUTINE MAT_MUL(A,B,C)
      DOUBLE PRECISION A(3,3),B(3,3),C(3,3)
      INTEGER I,J,K
      
      DO 10 I=1,3
         DO 20 J=1,3
            A(I,J)=0
   20    CONTINUE
   10 CONTINUE
   
      DO 30 I=1,3
         DO 40 J=1,3
            DO 50 K=1,3
               A(J,I)=A(J,I)+B(J,K)*C(K,I)
   50       CONTINUE
   40    CONTINUE
   30 CONTINUE
   
c      WRITE(*,*) 'NEW_MAT'
      
   
C
      RETURN
      END
C----------------------------------------------------------------  

C ******************************End Subroutine *********************************       
      SUBROUTINE WRITEMAT(A)
      DOUBLE PRECISION A(3,3)
      WRITE(*,1) A(1,1),A(1,2),A(1,3),A(2,1),A(2,2),A(2,3)
&            ,A(3,1),A(3,2),A(3,3)
1     FORMAT(3f10.4/3f10.4/3f10.4//)
      
      RETURN
      
      END
C ******************************End Subroutine ********************************* 

C ************************* Diffraction model ***********************************

      SUBROUTINE DIFFRACTION_PROB(POLE,INS_BEAM,TRANS_MATRIX,NO)
      
      DOUBLE PRECISION N_RES(3),P(3),POLE(30,3),DIFF_BEAM(3)
      DOUBLE PRECISION INS_BEAM(3),MAG,DEL_MAG_MAX,DEL_MAG_MIN
      DOUBLE PRECISION WAVE_LEN,AALPHA,A_GM,TRANS_MATRIX(3,3)
      DOUBLE PRECISION TRANS_MATRIX_IN(3,3),DIFF_BEAM_SA(3)
      DOUBLE PRECISION INS_BEAM_SA(3),A
      INTEGER I,NO
      
      WAVE_LEN=0.02
      A_GM=0.3
      A=SQRT(INS_BEAM(1)**2+INS_BEAM(2)**2+INS_BEAM(3)**2)
      
      DO 5 I=1,3
         INS_BEAM(I)=INS_BEAM(I)/A
5     CONTINUE

       
      INS_BEAM(1)=INS_BEAM(1)/WAVE_LEN
      INS_BEAM(2)=INS_BEAM(2)/WAVE_LEN
      INS_BEAM(3)=INS_BEAM(3)/WAVE_LEN
      
      DEL_MAG_MAX=(1/WAVE_LEN)+(1/WAVE_LEN)*0.02
      DEL_MAG_MIN=(1/WAVE_LEN)-(1/WAVE_LEN)*0.02
      
      DO 10 I=1,NO
      
         DO 20 J=1,3
            P(J)=POLE(I,J)
20       CONTINUE
                    
         CALL GET_NORMAL(N_RES,P,A_GM)
         
         DO 30 J=1,3
            DIFF_BEAM(J)=N_RES(J)+INS_BEAM(J)
30       CONTINUE
         
C         WRITE(*,*) 'NOR=',N_RES(1),N_RES(2),N_RES(3)
C         WRITE(*,*) 'INS_BEAM=',INS_BEAM(1),INS_BEAM(2),C
C&         INS_BEAM(3)
C         WRITE(*,*) 'DIFF=',DIFF_BEAM(1),DIFF_BEAM(2),DIFF_BEAM(3)
         
         MAG=SQRT(DIFF_BEAM(1)**2+DIFF_BEAM(2)**2+DIFF_BEAM(3)**2)
         
         CALL CALCULATE_INVERSE(TRANS_MATRIX,TRANS_MATRIX_IN)
         
         DO 40 K=1,3
            INS_BEAM_SA(K)=0.0
            DIFF_BEAM_SA(K)=0.0
40       CONTINUE
                     
         DO 50 K=1,3
            DO 60 J=1,3
               INS_BEAM_SA(K)= INS_BEAM_SA(K)+
&               TRANS_MATRIX_IN(K,J)*INS_BEAM(J)

               DIFF_BEAM_SA(K)= DIFF_BEAM_SA(K)+
&               TRANS_MATRIX_IN(K,J)*DIFF_BEAM(J)
60          CONTINUE
50      CONTINUE
        
C        WRITE(*,*) 'INS_BEAM=',INS_BEAM_SA(1),INS_BEAM_SA(2),
C&         INS_BEAM_SA(3)
C        WRITE(*,*) 'DIFF_SA=',DIFF_BEAM_SA(1),DIFF_BEAM_SA(2),
C&         DIFF_BEAM_SA(3)
         
         IF(MAG .LE. DEL_MAG_MAX .AND. MAG .GE. DEL_MAG_MIN) THEN
            CALL GET_XY_DIFF(DIFF_BEAM_SA,INS_BEAM_SA,NO)
         END IF
         

10    CONTINUE
      
      RETURN
      END
      
      
C ************************* GET NORMAL OF THE DIFFRACTED BEAM ******************

       SUBROUTINE GET_NORMAL(N,P,A)
       DOUBLE PRECISION N(3),P(3),A,D,K
       
C N is the reciprocal lattice vector representing diffracting planes
C D is the 1/d spacing of those planes

       D=DSQRT((P(1)*P(1)+P(2)*P(2)+P(3)*P(3))/(A*A))
       K=SQRT((P(1)*P(1)+P(2)*P(2)+P(3)*P(3)))
       
       N(1)=D*P(1)/K
       N(2)=D*P(2)/K
       N(3)=D*P(3)/K
       
       RETURN
       END
       
C *******************************************************************************

C ************************* GET NORMAL OF THE DIFFRACTED BEAM ******************

       SUBROUTINE GET_XY_DIFF(DIFF,INS,NO)
       
       DOUBLE PRECISION PI
       PARAMETER (PI=3.141592654)

       DOUBLE PRECISION DIFF(3),INS(3),A,B,DOT_PROD
       DOUBLE PRECISION Z,PLANE(3),ANG
       DOUBLE PRECISION ALPHAS,ALPHASS,ALPHA_NEW,X,Y
       DOUBLE PRECISION COS_ALPHAS,COS_ALPHASS
       INTEGER I,NO
       
       A=SQRT(DIFF(1)**2+DIFF(2)**2+DIFF(3)**2)
       
       DO 10 I=1,3
          DIFF(I)=DIFF(I)/A
10     CONTINUE

       B=SQRT(INS(1)**2+INS(2)**2+INS(3)**2)
       
       DO 20 I=1,3
          INS(I)=INS(I)/B
20     CONTINUE

       DOT_PROD=0
       
       DO 30 I=1,3
          DOT_PROD=DOT_PROD+INS(I)*DIFF(I)
30     CONTINUE

       ANG=ACOS(DOT_PROD)
       
       Z=TAN(ANG)*4
       
c       WRITE(*,*) 'DIFF=',DIFF(1),DIFF(2),DIFF(3)
c       WRITE(*,*) 'INS=',INS(1),INS(2),INS(3)
C       WRITE(*,*) 'DOT-PROD=',DOT_PROD
C       WRITE(*,*) 'ANG=',ANG
c       WRITE(*,*) 'Z=',Z   
       
       DO 40 I=1,3
          PLANE(I)=(DIFF(I)*4/DOT_PROD)-(INS(I)*4)
40     CONTINUE
       
       A=SQRT(PLANE(1)**2+PLANE(2)**2+PLANE(3)**2)
C       WRITE(*,*) 'PLANE=',PLANE(1),PLANE(2),PLANE(3)

       DO 50 I=1,3
          PLANE(I)=PLANE(I)/A
50       CONTINUE
       
       COS_ALPHAS=((1*PLANE(1))+(0*PLANE(2))+(0*PLANE(3)))

       ALPHAS=ACOS(COS_ALPHAS)
      
       COS_ALPHASS=((0*PLANE(1))+(1*PLANE(2))+(0*PLANE(3)))

       ALPHASS=ACOS(COS_ALPHASS)
      
       IF(ALPHAS .GE. PI/2) THEN
         ALPHA_NEW=PI-ALPHAS
       ELSE
         ALPHA_NEW=ALPHAS
       END IF
       
C       WRITE(*,*) 'ALPHA=',ALPHA_NEW,COS_ALPHAS,COS_ALPHASS
       IF(ALPHAS .GE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
         ALPHA_NEW=PI+ALPHA_NEW
       ELSE IF(ALPHAS .GE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
         ALPHA_NEW=PI-ALPHA_NEW
       ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
         ALPHA_NEW=ALPHA_NEW
       ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
         ALPHA_NEW=2*PI-ALPHA_NEW
       END IF
       
       X=Z*COS(ALPHA_NEW)
       Y=Z*SIN(ALPHA_NEW)
       
       
       
       WRITE(98,*) X,Y,NO
       
       RETURN
       END
       
C *******************************************************************************